package eMdP;



import java.net.URL;
import java.util.HashMap;
import java.util.LinkedList;

import jmetest.renderer.TestSkybox;

import com.acarter.scenemonitor.SceneMonitor;
import com.jme.image.Texture;
import com.jme.input.InputHandler;
import com.jme.input.MouseInput;
import com.jme.input.ThirdPersonHandler;
import com.jme.light.PointLight;
import com.jme.math.FastMath;
import com.jme.math.Vector3f;
import com.jme.renderer.Camera;
import com.jme.renderer.ColorRGBA;
import com.jme.scene.Node;
import com.jme.scene.Skybox;
import com.jme.scene.Text;
import com.jme.scene.shape.Box;
import com.jme.scene.state.LightState;
import com.jme.util.TextureManager;
import com.jme.util.Timer;
import com.jme.util.resource.ResourceLocatorTool;
import com.jme.util.resource.SimpleResourceLocator;
import com.jmex.bui.BComponent;
import com.jmex.bui.BContainer;
import com.jmex.bui.BImage;
import com.jmex.bui.BLabel;
import com.jmex.bui.background.ImageBackground;
import com.jmex.bui.enumeratedConstants.ImageBackgroundMode;
import com.jmex.bui.util.Point;
import com.jmex.physics.util.SimplePhysicsGame;

import eMdP.classesBasiques.Bustia;
import eMdP.classesBasiques.Escenari;
import eMdP.classesBasiques.Furgoneta;
import eMdP.classesBasiques.Personatge;
import eMdP.classesBasiques.PersonatgeNJ;
import eMdP.colisions.DeteccioColisions;
import eMdP.colisions.ImplCallBack;
import eMdP.estats.Partida;
import eMdP.gestors.GestorConstants;
import eMdP.gestors.GestorFitxers;
import eMdP.gestors.GestorModels;
import eMdP.gestors.GestorMusica;
import eMdP.inputHandler.EMdPHandler;

public class CopyOfProves extends SimplePhysicsGame {
	
	private PointLight pLight;
	private	LightState lState;
	boolean sceneMonitor=true;
	
	/* Variables de la Partida */

	
	public static void main(String[] args){
		CopyOfProves app = new CopyOfProves();
		app.setConfigShowMode(ConfigShowMode.AlwaysShow);
		
		app.start();
	}
	
	
	@Override
	protected void simpleInitGame() {
		
		Escenari escenari = GestorFitxers.carregarEscenari(0, getPhysicsSpace());
		rootNode.attachChild(escenari);
		
		// TODO Auto-generated method stubç
		try{
			ResourceLocatorTool.addResourceLocator(ResourceLocatorTool.TYPE_TEXTURE,
                new SimpleResourceLocator(CopyOfProves.class.getClassLoader().getResource("eMdP/altresModels/TEX/")));
		}catch(Exception e){System.out.println("Petaaa que da gustoooo");}
		
		Node patat = GestorModels.get3DS("eMdP/altresModels/furgo.3ds");
		patat.setLocalTranslation(0,0,0);
		patat.setLocalScale(3);
		patat.getLocalRotation().fromAngles(FastMath.HALF_PI*3, FastMath.HALF_PI, 0);
		
		rootNode.attachChild(patat);
		
		
		rootNode.updateRenderState();

		if(sceneMonitor){
			SceneMonitor.getMonitor().registerNode(rootNode, "Root Node");
			SceneMonitor.getMonitor().showViewer(true);
		}
		
		pLight = new PointLight();
    	pLight.setLocation(new Vector3f(15,50,-15));
    	//pLight.setDiffuse(ColorRGBA.red);
    	
    	pLight.setAmbient(ColorRGBA.white);
    	pLight.setAttenuate(false);
    	pLight.setConstant(5);
    	pLight.setEnabled(true);
    	lState = display.getRenderer().createLightState();
    	lState.attach(pLight);
    	rootNode.setRenderState(lState);
    	
        rootNode.updateRenderState();
        
        cam.setLocation(new Vector3f(0,20,-15));
        cam.lookAt(new Vector3f(0,0,0), new Vector3f(0,1,0));
	}
	
	
	
	/*private void creemCamera(){
		cam = display.getRenderer().getCamera();
		/* Col·loquem la càmera a la pos 0,17,-18 */
		/*cam.setLocation(new Vector3f(0,17,-18));
		/* Apuntem la camera cap a la 0,-0.65,0.75 */
    	/*cam.lookAt(new Vector3f(0,-0.65f,0.75f), new Vector3f(0,1,0));
    	cam.update();
	}*/
	
	
	@Override
	public void simpleUpdate(){
		
		cam.update();
		
		if(sceneMonitor)
			SceneMonitor.getMonitor().updateViewer(tpf);
		
	}
	
	@Override
	public void simpleRender(){
		if(sceneMonitor)
			SceneMonitor.getMonitor().renderViewer(display.getRenderer());
	}
	
	
	
}

