package eMdP;


import java.net.URL;
import java.util.HashMap;
import java.util.LinkedList;

import jmetest.renderer.TestSkybox;

import com.acarter.scenemonitor.SceneMonitor;
import com.jme.image.Texture;
import com.jme.input.InputHandler;
import com.jme.input.MouseInput;
import com.jme.input.ThirdPersonHandler;
import com.jme.light.PointLight;
import com.jme.math.FastMath;
import com.jme.math.Vector3f;
import com.jme.renderer.Camera;
import com.jme.renderer.ColorRGBA;
import com.jme.scene.Node;
import com.jme.scene.Skybox;
import com.jme.scene.Text;
import com.jme.scene.state.LightState;
import com.jme.util.TextureManager;
import com.jme.util.Timer;
import com.jme.util.resource.ResourceLocatorTool;
import com.jme.util.resource.SimpleResourceLocator;
import com.jmex.bui.BComponent;
import com.jmex.bui.BContainer;
import com.jmex.bui.BImage;
import com.jmex.bui.BLabel;
import com.jmex.bui.background.ImageBackground;
import com.jmex.bui.enumeratedConstants.ImageBackgroundMode;
import com.jmex.bui.util.Point;
import com.jmex.physics.util.SimplePhysicsGame;

import eMdP.classesBasiques.Bustia;
import eMdP.classesBasiques.Escenari;
import eMdP.classesBasiques.Furgoneta;
import eMdP.classesBasiques.Personatge;
import eMdP.classesBasiques.PersonatgeNJ;
import eMdP.colisions.DeteccioColisions;
import eMdP.colisions.ImplCallBack;
import eMdP.estats.Partida;
import eMdP.gestors.GestorConstants;
import eMdP.gestors.GestorFitxers;
import eMdP.gestors.GestorModels;
import eMdP.gestors.GestorMusica;
import eMdP.inputHandler.EMdPHandler;

public class Proves extends SimplePhysicsGame {
	
	private Text infotext;
	private Text temporitzador;
	private Text paquetsE;
	
	private Node statNode;
	
	private Timer timer;
	private InputHandler[] inputeta;
	
	private DeteccioColisions dp;
	
	private Camera cam;

	private PointLight pLight;
	private	LightState lState;
	
	private LinkedList<Bustia> busties = new LinkedList<Bustia>();
	private LinkedList<PersonatgeNJ> pnjs = new LinkedList<PersonatgeNJ>();
	private LinkedList<Furgoneta> furgonetes = new LinkedList<Furgoneta>();
	private LinkedList<Personatge> jugadors = new LinkedList<Personatge>();
	private Escenari escenari;
	
	boolean sceneMonitor=true;
	
	/* Variables de la Partida */
	private int iniciJoc;
	private int tipusJoc;
	private int paquetsAEntrar = GestorConstants.PAQUETS_PER_PARTIDA;
	private float tempsPerPartida = GestorConstants.TEMPS_PER_PARTIDA;
	private boolean trobat=false; //Variable que ens indica si algun jugador ha superat els paquets a entrar
	private int jugadorGuanyador; //id del jugador que ha guanyat
	
	public static void main(String[] args){
		Proves app = new Proves();
		app.setConfigShowMode(ConfigShowMode.AlwaysShow);
		
		app.start();
	}
	
	
	@Override
	protected void simpleInitGame() {
		// TODO Auto-generated method stubç
		
		int mode= 0;
		int[] idPersonatges = new int[3];
		idPersonatges[0] = 0;
		idPersonatges[1] = 1;
		idPersonatges[2] = 2;
		int idEscenari = 0;

		if(sceneMonitor){
			SceneMonitor.getMonitor().registerNode(rootNode, "Root Node");
			SceneMonitor.getMonitor().showViewer(true);
		}
		
		/*Fem visible el ratolí */
    	MouseInput.get().setCursorVisible(true);
    	
    	/* Assignem el mode de joc a la variable de la Partida */
		tipusJoc = mode;
		
		creemEscenari(idEscenari);
		creemJugadors(idPersonatges);
		creemBusties();
		creeemPNJS();
		//buildGui();
		creemFurgonetes();
		creemLlums();
		
		/* Un cop temim tots els personatges i objectes que participaran a la partida inicialitzem les opcions */
		/* Creem la càmera i la posicionem allà a on ens interessa */
    	creemCamera();
    	
    	/* Creem el control dels jugadors */
    	setupInput(idPersonatges.length);
    	
    	/* Creem les col·lisions */
    	setupColisions();
    	
    	/* Creem el timer */
    	timer = Timer.getTimer();
    	
    	/* Creem la gravetat */
    	getPhysicsSpace().setDirectionalGravity( new Vector3f( 0, -50, 0 ) );
    	
    	/* Creem la musica */
    	GestorMusica.CrearMusica(cam);
    	/* Reproduim la musica del joc */
    	//musica.play();
    	
    	
    	/* Creem el Node estat, a on penjaran tots els textes que es mostraran per pantalla */
        statNode = new Node("estat");
        creemTextosMostrarPantalla();
        
        /* Assignem l'statNode al rootNode */
        rootNode.attachChild(statNode);

       // buildSkyBox();
        iniciJoc = (int)timer.getTimeInSeconds();
	}
	
	private void creemEscenari(int id){
		escenari = GestorFitxers.carregarEscenari(id, getPhysicsSpace());
		rootNode.attachChild(escenari);
		
		// TODO Auto-generated method stubç
		try{
			ResourceLocatorTool.addResourceLocator(ResourceLocatorTool.TYPE_TEXTURE,
                new SimpleResourceLocator(CopyOfProves.class.getClassLoader().getResource("eMdP/altresModels/TEX/")));
		}catch(Exception e){System.out.println("Petaaa que da gustoooo");}
		
		Node patat = GestorModels.get3DS("eMdP/altresModels/furgo.3ds");
		patat.setLocalTranslation(0,0,0);
		patat.setLocalScale(3);
		patat.getLocalRotation().fromAngles(FastMath.HALF_PI*3, FastMath.HALF_PI, 0);
		
		rootNode.attachChild(patat);
	}
	
	private void creemBusties(){
		Bustia a;
		for(int i=0;i<escenari.getNumBusties();i++){
			a = new Bustia("bustia"+i,GestorConstants.DIRECCIO_BUSTIA,i,getPhysicsSpace().createStaticNode());
			escenari.attachChild(a);
			a.setLocalTranslation(escenari.getPosBusties().get(i));
			busties.add(a);
			System.out.println("Això és la bustia: "+i);
		}
	}
	
	private void creeemPNJS(){
		PersonatgeNJ p;
		
		for(int i=0;i<escenari.getNumPNJS();i++){
			p = new PersonatgeNJ("NJ"+i,6,getPhysicsSpace(),0.8f,4+i);
			//p.setLocalScale(0.2f);
			escenari.attachChild(p);
			p.setLocalTranslation(escenari.getPosPNJS().get(i).add(0, 3, 0));
			p.lookAt(new Vector3f(0,0,0), new Vector3f(0,1,0));
			//color(p,ColorRGBA.red);
			pnjs.add(p);
		}	
		//escenari.attachChild(GestorModels.getJMEXML(GestorConstants.DIRECCIO_PNJ));
	}

	private void creemFurgonetes(){
		Furgoneta g;
		for(int i=0;i<escenari.getNumFurgos();i++){
			Vector3f posFinal = new Vector3f();
			Vector3f posArribada = escenari.getPosFurgonetes().get(i);
			if(posArribada.x>0)
				posFinal.set(escenari.getPosFurgonetes().get(i)).addLocal(50, 0, 0);
			else
				posFinal.set(escenari.getPosFurgonetes().get(i)).addLocal(-50, 0, 0);
			
			g = new Furgoneta("FurgoCorreus"+i,getPhysicsSpace().createStaticNode(),posArribada,posFinal,true);
			escenari.attachChild(g);
			g.setLocalTranslation(posArribada);
			System.out.println("Furgoneta "+i+": "+g.getLocalTranslation());
			furgonetes.add(g);
		}
	}

	private void creemJugadors(int[] idsPersonatges){
		
		Personatge a;
		System.out.println("Les ids dels personatges son: ");
		for(int i=0;i<idsPersonatges.length;i++){
			System.out.print(idsPersonatges[i]+", ");
			//a = new Personatge("Jugador"+i,i,getPhysicsSpace().createStaticNode());
			a = GestorFitxers.carregarPersonatge(idsPersonatges[i], getPhysicsSpace());
			escenari.attachChild(a);
			a.setIdJugador(i);
			//a.setLocalScale(0.25f);
			//a.setLocalTranslation(escenari.getPosJugadors().get(i));
			//a.setLocalTranslation(new Vector3f(0,0.3f,0));
			//a.getLocalTranslation().set(new Vector3f(escenari.getPosJugadors().get(i)));
			//a.setLocalTranslation(escenari.getPosJugadors().get(i));
			//a.colocarA(escenari.getPosJugadors().get(i));
			//a.getLocalTranslation().addLocal(escenari.getPosJugadors().get(i));
			a.mirarAlCentre();
			//a.setLocalScale(0.2f);
			jugadors.add(a);
		}
	}
	
	private void creemLlums(){
		
		pLight = new PointLight();
    	pLight.setLocation(new Vector3f(15,50,-15));
    	//pLight.setDiffuse(ColorRGBA.red);
    	
    	pLight.setAmbient(ColorRGBA.white);
    	pLight.setAttenuate(false);
    	pLight.setConstant(5);
    	pLight.setEnabled(true);
    	lState = display.getRenderer().createLightState();
    	lState.attach(pLight);
    	rootNode.setRenderState(lState);
    	
        rootNode.updateRenderState();
	}
	
	private void setupInput(int numInputs) {
        //inputeta = new EMdPControls(jugador,jugador.getId(),timer,musica);
    	//inputeta = new EMdPControlsJoystick(jugador,0,timer,musica); //0 indica el numero de joystick
    	//inputeta2 = new EMdPControlsJoystick(jugador2,1,timer,musica); //0 indica el numero de joystick
        //inputeta2 = new EMdPControls(jugador2,jugador2.getId(),timer,musica);
    	//input = new EMdPControls(enemig, settings.getRenderer());
		inputeta = new EMdPHandler[numInputs];
		for(int i=0;i<numInputs;i++){
	    	 HashMap<String, Object> handlerProps = new HashMap<String, Object>();
	         handlerProps.put(EMdPHandler.PROP_DOGRADUAL, "true");
	         handlerProps.put(EMdPHandler.PROP_TURNSPEED, ""+(1.5f * FastMath.PI));
	         handlerProps.put(EMdPHandler.PROP_CONTROL_ENTRADA, 0);
	         //Hauriem d'anar a buscar unes constants per definir els controls de cada jugador
	         //De moment tots es mouen amb IKLJ
	         inputeta[i] = new EMdPHandler(jugadors.get(i),cam,handlerProps,getPhysicsSpace());
	         inputeta[i].setActionSpeed(10f);
		} 
    }
	
	private void setupColisions(){
		/* DeteccioColisions controla les col·lisions dels nodes estàtics */
    	//dp = new DeteccioColisions(jugadors,pnjs,furgonetes,busties,escenari,getPhysicsSpace());
    	/* Creem la CallBack, classe que controla les col·lisions de nodes Dynamics */
    	new ImplCallBack(getPhysicsSpace(),rootNode);
    	//logger.info("PARTIDA::Instal·lem el detector de col·lisions");
    }
	
	private void creemCamera(){
		cam = display.getRenderer().getCamera();
		/* Col·loquem la càmera a la pos 0,17,-18 */
		//cam.setLocation(new Vector3f(0,17,-18));
		cam.setLocation(new Vector3f(0,140,240));
		/* Apuntem la camera cap a la 0,-0.65,0.75 */
    	//cam.lookAt(new Vector3f(0,-0.65f,0.75f), new Vector3f(0,1,0));
		cam.lookAt(new Vector3f(0,-1,0), new Vector3f(0,1,0));
    	cam.update();
	}
	
	private void creemTextosMostrarPantalla(){
		infotext = Text.createDefaultTextLabel("text informatiu");
        infotext.getLocalTranslation().set( 0, 20, 0 );
        statNode.attachChild( infotext );
          
        temporitzador = Text.createDefaultTextLabel("Temporitzador");
        temporitzador.getLocalTranslation().set( display.getWidth()/2, display.getHeight()-20, 0 );
        statNode.attachChild( temporitzador );
          
        paquetsE = Text.createDefaultTextLabel("Paquets entrats");
        paquetsE.getLocalTranslation().set(10, display.getHeight()-20, 0 );
        statNode.attachChild( paquetsE );
	}
	
	@Override
	public void simpleUpdate(){
		//super.update(tpf);
		
		cam.update();
		if((tipusJoc == 1 && !trobat) || ((tempsPerPartida - timer.getTimeInSeconds() + iniciJoc) > 0))
    	{ 
	        
			/* Actualitzem la posició de les furgonetes i dels Personatges No Jugadors */
			for(int i=0;i<furgonetes.size();i++)
				furgonetes.get(i).actualitzar(timer.getTimeInSeconds());
			
			
			for(int i=0;i<pnjs.size();i++)
				//pnjs.get(i).update(timer.getTimePerFrame());
				pnjs.get(i).actualitzar(timer.getTimeInSeconds());
	        
	    	//dp.ProcessCollisionsNou();
			for(int i=0;i<jugadors.size();i++){
				inputeta[i].update(timer.getTimePerFrame());
			}
	    	/*temporitzador.print(""+(int)((tipusJoc* (-tempsPerPartida)) + timer.getTimeInSeconds() - iniciJoc));
	    	paquetsE.print("Jugador 1: "+jugadors.get(0).quantsPaquetsHaEntrat());
	    	rootNode.updateRenderState();
	    	rootNode.updateGeometricState(tpf, true);
	    	//musica.update();*/
	    	int i=0;
	    	/*while(i<jugadors.size() && !trobat){
	    	//for(int i =0;i<jugadors.size();i++){
	    		trobat = jugadors.get(i).quantsPaquetsHaEntrat() >= paquetsAEntrar;
	    		if(trobat)jugadorGuanyador=i;
	    		i++;
	    	}*/
    	}
		else
		{
    		//GestorPantalla.guardarPuntuacions();
			temporitzador.setLocalScale(3);
    		temporitzador.setLocalTranslation(0, display.getHeight()/2, 0);
    		temporitzador.setDefaultColor(ColorRGBA.red);
    		temporitzador.print("Guanya: "+jugadors.get(jugadorGuanyador).getName());
    	}	
		
		if(sceneMonitor)
			SceneMonitor.getMonitor().updateViewer(tpf);
		
	}
	
	@Override
	public void simpleRender(){
		//super.render(tpf);
		if(sceneMonitor)
			SceneMonitor.getMonitor().renderViewer(display.getRenderer());
	}
	
	/*private void buildGui()
	{
		window.setSize((int)(display.getWidth()),(int)(display.getHeight()));
		BImage bustia; BImage paquet;
		URL urlBustia = Partida.class.getClassLoader().getResource(GestorConstants.DIRECCIO_IMATGE_BUSTIA);
		URL urlPaquet = Partida.class.getClassLoader().getResource(GestorConstants.DIRECCIO_IMATGE_PAQUET);
		BContainer contenidor;
		BLabel text;
		
		
		int unQuart = display.getWidth()/4;
		//int unVuite = display.getWidth()/8;
		int unSetze = display.getWidth()/16;
		
		for(int i = 0;i<jugadors.size();i++)
		{
			int posicioY = display.getHeight()-GestorConstants.ALT_BOTO-GestorConstants.ESPAI_ENTRE_ELEMENTS_GBUI;
			
			text = new BLabel(jugadors.get(i).getNom());
			text.setPreferredSize(unQuart, GestorConstants.ALT_BOTO);
			window.add(text, new Point(unQuart*i, posicioY));
			
			posicioY = posicioY-GestorConstants.PIXELS_IMATGE_ICONA-GestorConstants.ESPAI_ENTRE_ELEMENTS_GBUI;
			
			try
		   	{
				bustia = new BImage(urlBustia);
				paquet = new BImage(urlPaquet);
				
				contenidor = new BContainer("Bustia");
				contenidor.setBackground(BComponent.DEFAULT, new ImageBackground(ImageBackgroundMode.SCALE_XY, bustia));
				contenidor.setPreferredSize(44, 44);
				contenidor.setHoverEnabled(false);
				window.add(contenidor, new Point(unQuart*i+unSetze, posicioY));
				text = new BLabel("0");
				window.add(text, new Point(unQuart*i+unSetze+44, posicioY));
				contenidor = new BContainer("Paquet");
				contenidor.setBackground(BComponent.DEFAULT, new ImageBackground(ImageBackgroundMode.SCALE_XY, paquet));
				contenidor.setPreferredSize(44, 44);
				contenidor.setHoverEnabled(false);
				window.add(contenidor, new Point(unQuart*i+unSetze,GestorConstants.ESPAI_ENTRE_ELEMENTS_GBUI));
				text = new BLabel("0");
				window.add(text, new Point(unQuart*i+unSetze+44, GestorConstants.ESPAI_ENTRE_ELEMENTS_GBUI));
				
		   	} catch (Exception e)
		   	{
		   		System.out.println("No entro dintre el try de les imatges!");
		   	};
		}
	}*/

	
	
	
}
