package eMdP;
import java.net.URL;

import com.jme.renderer.ColorRGBA;
import com.jme.renderer.Renderer;
import com.jme.scene.shape.Quad;
import com.jme.system.DisplaySystem;
import com.jme.util.Timer;
import com.jmex.game.StandardGame;
import com.jmex.game.state.BasicGameState;
import com.jmex.game.state.GameStateManager;
import com.jmex.game.state.load.TransitionGameState;

import eMdP.gestors.GestorModels;
import eMdP.gestors.GestorMusica;


public class ProvesGameStates {

	private static StandardGame game;
	
	public static void main(String[] args) {

	    
	    /*
	     * FIRST GAME STATE
	     */
	    class MyFirstGameState extends BasicGameState {

	        private boolean mark;

	        public MyFirstGameState() {
		    	super("MyFirstGameState");
		    	this.rootNode.setRenderQueueMode(Renderer.QUEUE_ORTHO);	
		    	
		    	Quad topQuad = new Quad("firstQuad", 400, 200);
		    	topQuad.setLocalTranslation(200, 100, 1);
		    	topQuad.setSolidColor(new ColorRGBA(1f, 0f, 0f, 1f));
		    	this.getRootNode().attachChild(topQuad);
		    	
		    	this.rootNode.updateRenderState();
		    	
		    	
	        }
	        
	        private void createTransition() {
	    	// Create TransitionGameState
	    	URL url = MyFirstGameState.class.getClassLoader().getResource("res/woodBckg.png");
	    	TransitionGameState transition = new TransitionGameState(this, url);
	    	GameStateManager.getInstance().attachChild(transition); // Attach
	    	transition.setActive(true); // Active it
	    	transition.setProgress(0f, "");
	    	GameStateManager.getInstance().activateChildNamed("MySecondGameState"); // Attach
	    	transition.setProgress(1f, "");
	        }
	        
	        public void update(float tpf) {
	    	    super.update(tpf);
	    	    Timer timer = Timer.getTimer();
	    	    if (timer.getTimeInSeconds() > 5f) {
	    	        if (!this.mark) {
	    		    this.mark = true;
	    		    this.createTransition();
	    	        }

	    	    }
	        }
	    }	    
	    
	    
	    
	    class MySecondGameState extends BasicGameState {

		    public MySecondGameState() {
			super("MySecondGameState");
			this.getRootNode().setRenderQueueMode(Renderer.QUEUE_ORTHO);	
			
			Quad topQuad = new Quad("secondQuad", 400, 200);
			topQuad.setLocalTranslation(200, 100, 1);
			topQuad.setSolidColor(new ColorRGBA(0f, 0f, 1f, 1f));
			this.getRootNode().attachChild(topQuad);
			
			this.getRootNode().updateRenderState();	
		    }    
		    
		}
	    
	    
	    
	    /*
	     *  LAUNCH THE GAME
	     */
	    ProvesGameStates.game = new StandardGame("StandardGame");
	    ProvesGameStates.game.getSettings().setWidth(400);
	    ProvesGameStates.game.getSettings().setHeight(200);
    		
    		// START HACK SOUND
	    ProvesGameStates.game.getSettings().setVerticalSync(false);
	    ProvesGameStates.game.getSettings().setMusic(false);
	    ProvesGameStates.game.getSettings().setSFX(false);
    		// END HACK SOUND
    		
	    ProvesGameStates.game.start();
	    ProvesGameStates.game.getDisplay().setTitle("jMe Test Area");
    		
    		//GameStateManager.getInstance().attachChild(new MyGameStateNode());
    		GameStateManager.getInstance().attachChild(new MyFirstGameState());
    		GameStateManager.getInstance().attachChild(new MySecondGameState());
    		GameStateManager.getInstance().activateChildNamed("MyFirstGameState");
		
	}
	
}