package eMdP.classesBasiques;

import com.jme.bounding.BoundingBox;
import com.jme.intersection.PickData;
import com.jme.intersection.PickResults;
import com.jme.intersection.TrianglePickResults;
import com.jme.math.FastMath;
import com.jme.math.Quaternion;
import com.jme.math.Ray;
import com.jme.math.Vector3f;
import com.jme.scene.Spatial;
import com.jme.util.Timer;
import com.jmex.physics.DynamicPhysicsNode;
import com.jmex.physics.PhysicsSpace;
import com.jmex.physics.StaticPhysicsNode;

import eMdP.gestors.GestorConstants;

/**
 * PersonatgeNJ és una herencia de Personatge que controla el moviment del jugador al joc. A part
 * de tots els atributs de la classe Personatge, la classe PersonatgeNJ té l'atribut de "IA", que controla la
 * intel·ligéncia Artificial del PNJ. 
 * 
 * @author Peppino Coorp.
 */

public class PersonatgeNJ extends Personatge{
	private static final long serialVersionUID = 1L;
	
	//private static final Logger logger = Logger.getLogger(Partida.class.getName());
	
	//private float angle = 0;
	
	/* Variables que defineixen el valor màxim per mirar a la dreta i a l'esquerra */
	//private int maxDreta = 25;
	//private int maxEsquerra = -25;
	
	// Variables que defineixen les seves característiques físiques 
	private float visio;
	
	public PersonatgeNJ(String nom, float visio, PhysicsSpace espaiFisic, float força, int id){
		super(nom,"","",GestorConstants.DIRECCIO_PNJ,espaiFisic,força,id);
		this.visio = visio;
	}

	/**
	 * Basic constructor básic, que simplement assigna un nom al Node, i carrega
	 * l'aspecte gràfic del Personatge No Jugador
	 * 
	 * @param nom El nom del PersonatgeNJ
	 * @param visio La intel·ligéncia Artificial que tindrà el PNJ
	 * @param model El model que representa gràficament el PersonatgeNJ
	 * @param nodeEstatic El node físic, que conté les físiques del PersonatgeNJ
	 */
	/*public PersonatgeNJ(String nom, float visio,Spatial model, DynamicPhysicsNode nodeFisic) {
		//super(nom,model,nodeEstatic);
		super(nom,1,model,nodeFisic);	//L'1 és la id del Persaontge
		this.visio = visio;
	}*/
	
	/**
	 * Basic constructor básic, que simplement assigna un nom al Node, i carrega
	 * l'aspecte gràfic del PersonatgeNJ
	 * 
	 * @param nom El nom del PersonatgeNJ
	 * @param visio La intel·ligéncia Artificial que tindrà el PNJ
	 * @param nodeEstatic El node físic, que conté les físiques del PersonatgeNJ
	 */
	/*public PersonatgeNJ(String nom, float visio, DynamicPhysicsNode nodeEstatic) {
		super(nom,1,nodeEstatic); //L'1 és la id del Persaontge
		this.visio = visio;
	}

	/**
	 * Constructor que assigna tots els atributs del PersonatgeNJ
	 * 
	 * @param nom El nom del PersonatgeNJ
	 * @param descripcio Les característiques del PersonatgeNJ, així com nacionalitat, i altres coses inútils
	 * @param fotoInicial Imatge que es mostrarà per escollir el PersonatgeNJ
	 * @param model El model que representa gràficament el PersonatgeNJ
	 * @param textura Serveix per la segona equipació del PersonatgeNJ
	 * @param ossos Situació de l'arxiu que conté els ossos del PersonatgeNJ
	 * @param animacio Situació de l'arxiu que conté l'animació del PersonatgeNJ
	 * @param força Característica Física que influirà en la força que llança un Paquet el PersonatgeNJ
	 * @param velocitat Característica Física que influirà en la velocitat en que es mourà el PersonatgeNJ
	 * @param agilitat Característica Física que influirà en la puntaria, temps que tarda a aixecar-se,... el PersonatgeNJ
	 */
	/*public PersonatgeNJ(String nom, String descripcio, String fotoInicial,
			Spatial model, DynamicPhysicsNode nodeFisic, String textura, String ossos, String animacio,
			float força, float velocitat, float agilitat, float visio) {
		super(nom,descripcio,fotoInicial,model,nodeFisic,textura,ossos,animacio,força,velocitat,agilitat);
		this.visio = visio;
	}

	
	
	/* ----------------------------------  Fi dels GETTES/SETTERS  -------------------------------------------- */
	
	/**
	 * Metode que retorna cert si és un PErsonatge jugador i fals altrament
	 * @return socPersonatge
	 */
	public boolean socPersonatge(){
		boolean socPersonatge = false;
		return socPersonatge;
	}
	
	/**
	 * @param posicio Vector3f que conté la nova direcció del nodeEstatic
	 */
	public void setLocalTranslation(Vector3f posicio){
		super.setLocalTranslation(posicio);
	}
	
	/**
	 * @return La posició Local que està el node Estàtic
	 */
	public Vector3f getLocalTranslation(){
		return super.getLocalTranslation();
	}
	
	/**
	 * @param posicio Vector3f que conté la nova direcció del nodeEstatic
	 */
	public void setLocalRotation(Quaternion posicio){
		super.setLocalRotation(posicio);
	}
	
	/**
	 * @return La posició Local que està el node Estàtic
	 */
	public Quaternion getLocalRotation(){
		return super.getLocalRotation();
	}
	
	/**
	 * Métode per saber el nombre de paquets que té un personatge. El que fem és mirar quants fills té i li restem 2 que son el seu model
	 * @return El nombre de paquets que té aquest Personatge
	 */
	/*public int quantsFills(){
		return super.quantsFills();
	}
	
	/**
	 * Métode que fa una cerca del jugador. Llença raigs 50º al voltant del PersonatgeNJ i crida al métode <code>hiHaJugadorDavant(PickResults resultat)</code>,
	 * en cas de trobar-lo retorna la direcció en que està, sino retorna la posició inicial del PNJ.
	 * 
	 * @param origen Vector3f que ens indica a on està posicionat el PNJ per tal de poder llançar ratjos des d'aquest punt
	 * @return direccio Quaterion que conté o la direcció a on hi ha el jugador, o la direcció inicial a la que mirava el PNJ
	 */
	/*private Quaternion buscarAlVoltant(Vector3f origen,float temps){
		
		//Inicialitzem el retorn, cap on mira inicialment
		Quaternion direccio = new Quaternion(this.getNodeEstatic().getLocalRotation());
		boolean trobat = false;
		int i = 0;
		
		/* Fem una cerca desde maxEsquerra fins a maxDreta si trobem el jugador parem i retornem la direccio */
		/*while(i < 360 && !trobat){
			Quaternion rotQuat = new Quaternion();
			rotQuat.set(this.getLocalRotation());
			rotQuat.fromAngleAxis(i, new Vector3f(0, 1, 0));
			
			PickResults results = llançarRaig(origen,rotQuat.getRotationColumn(2, new Vector3f()));
			
			if(hiHaJugadorDavant(results,temps)){
				trobat=true;
				direccio.set(rotQuat);
			}
			
			i++;
		}
		
		
		return direccio;
	}*/
	
	/**
	 * Métode que li passem un PickResults (conté totes les col·lisions d'un raig), i busca si a la segona posició hi ha el jugador. Mirem la segona
	 * perqué a la primera hi ha d'haver la caixa de l'enemig, per tant la segona ha de ser el Jugador.
	 * 
	 * @return trobat Cert si hi ha el jugador i no està immune ni bloquejat, Fals altrament.
	 */
	/*private boolean hiHaJugadorDavant( PickResults results,float temps){
		
		boolean trobat = false;
		
		if(results.getNumber() > 1) {
			//for(int i=0;i<results.getNumber();i++){
				/* Agafem la col·lisio 1, perqué la 0 conté el model del pnj */
			/*	PickData closest = results.getPickData(1); //Com que estan ordenats els objectes del Ray, el 1er és l'enemig i si el 2on es Jugador perseguim!
				
				if(closest.getDistance()<IA && esFillDUnPersonatge(closest.getTargetMesh(),temps)){
					trobat=true;
				}
			//}
		}
		return trobat;
	}*/
	
	/**
	 * Llença un raig que passa per el punt origen amb la direccio passada per parametres. Retorna un PickResults que conté totes les col·lisions
	 * obtingudes i ordenades per ordre de proximitat
	 * 
	 * @param origen Vector3f que indica el punt d'origen des de on llancem el raig.
	 * @param direccio Vector3f La direcció en que llancem el raig
	 * 
	 * @return results PickResults que conté totes les col·lisions que ha fet el raig.
	 */
	/*private PickResults llançarRaig(Vector3f origen,Vector3f direccio){
		
		Ray ray = new Ray(origen, direccio);
		PickResults results = new TrianglePickResults();
		results.setCheckDistance(true);
		this.getParent().findPick(ray,results);
		
		return results;
	}
	*/
	/**
	 * El PersoantgeNJ està quiet mirant al seu voltant, i segons l'atribut IA, veu més lluny o més aprop. Si et veu et persegueix.
	 * Métode per controlar els moviments del PersonatgeNJ. Consisteix en anar llançant Rays per veure't, si et veu, i estas a una 
	 * distància inferior a IA et persegueix.
	 */
	/*public void actualitzar(float temps){
		/* LLancem Raig endevant per veure si veiem algu */
		/*if(!this.estaBloquejat(temps)){
			PickResults resultats = llançarRaig(this.getNodeEstatic().getLocalTranslation(), this.getLocalRotation().getRotationColumn(2, new Vector3f()));
			if(hiHaJugadorDavant(resultats,temps)){
				Vector3f loc = this.getLocalTranslation();
				loc.addLocal(this.getLocalRotation().getRotationColumn(2, new Vector3f()).multLocal(super.getVelocitat()));
				this.setLocalTranslation(loc);
			}else{
				this.setLocalRotation(buscarAlVoltant( this.getNodeEstatic().getLocalTranslation(),temps));
			}
		}else{
			//System.out.println("Soc el NJ x i estic bloquejat: "+this.getName());
		}
	}
	
	private boolean esFillDUnPersonatge(Spatial node,float temps){
		boolean trobat=false;

		if(!node.equals(this.getParent()))
		{
			if(node instanceof Personatge)
			{
				trobat=true;
				trobat = ((Personatge)node).socPersonatge();
				if(trobat){
					trobat= (!((Personatge)node).estaBloquejat(temps) && !((Personatge)node).isImmune(temps));
				}
			}
			else trobat= esFillDUnPersonatge(node.getParent(),temps);
		}
		return trobat;
	}*/

	
private Quaternion buscarAlVoltant(Vector3f origen,float temps){
		
		//Inicialitzem el retorn, cap on mira inicialment
		Quaternion direccio = new Quaternion(this.getLocalRotation());
		boolean trobat = false;
		int i = 0;
		
		/* Fem una cerca desde maxEsquerra fins a maxDreta si trobem el jugador parem i retornem la direccio */
		while(i < 360 && !trobat){
			Quaternion rotQuat = new Quaternion();
			rotQuat.set(this.getLocalRotation());
			rotQuat.fromAngleAxis(FastMath.DEG_TO_RAD*i, new Vector3f(0, 1, 0));
			
			PickResults results = llançarRaig(origen,rotQuat.getRotationColumn(2, new Vector3f()));
			
			if(hiHaJugadorDavant(results,temps)){
				trobat=true;
				direccio.set(rotQuat);
				System.out.println("Em trobat el jugador!!!!");
			}
			
			i++;
		}
		
		
		return direccio;
	}
	
	/**
	 * Métode que li passem un PickResults (conté totes les col·lisions d'un raig), i busca si a la segona posició hi ha el jugador. Mirem la segona
	 * perqué a la primera hi ha d'haver la caixa de l'enemig, per tant la segona ha de ser el Jugador.
	 * 
	 * @return trobat Cert si hi ha el jugador i no està immune ni bloquejat, Fals altrament.
	 */
	private boolean hiHaJugadorDavant( PickResults results,float temps){
		
		boolean trobat = false;
		
		if(results.getNumber() > 1) {
				/* Agafem la col·lisio 1, perqué la 0 conté el model del pnj */
				PickData closest = results.getPickData(1); //Com que estan ordenats els objectes del Ray, el 1er és l'enemig i si el 2on es Jugador perseguim!
				if(closest.getDistance()<visio && esFillDUnPersonatge(closest.getTargetMesh(),temps)){
					trobat=true;
					System.out.println("Hi ha jugador al davant");
				}else{
					//System.out.println("No es un jugador: "+closest.getTargetMesh().getParent().getParent().getParent().getName());
				}
				
		}
		return trobat;
	}
	
	/**
	 * Llença un raig que passa per el punt origen amb la direccio passada per parametres. Retorna un PickResults que conté totes les col·lisions
	 * obtingudes i ordenades per ordre de proximitat
	 * 
	 * @param origen Vector3f que indica el punt d'origen des de on llancem el raig.
	 * @param direccio Vector3f La direcció en que llancem el raig
	 * 
	 * @return results PickResults que conté totes les col·lisions que ha fet el raig.
	 */
	private PickResults llançarRaig(Vector3f origen,Vector3f direccio){
		
		Ray ray = new Ray(origen, direccio);
		PickResults results = new TrianglePickResults();
		results.setCheckDistance(true);
		this.getParent().findPick(ray,results);
		
		return results;
	}
	
	/**
	 * El PersoantgeNJ està quiet mirant al seu voltant, i segons l'atribut IA, veu més lluny o més aprop. Si et veu et persegueix.
	 * Métode per controlar els moviments del PersonatgeNJ. Consisteix en anar llançant Rays per veure't, si et veu, i estas a una 
	 * distància inferior a IA et persegueix.
	 */
	public void actualitzar(float temps){
		// Actualitzem la força per mantenir dempeus el PNJ
		update(Timer.getTimer().getTimePerFrame());
		// Comprovem que no estigui bloquejat
		if(!this.estaBloquejat(temps)){
			Vector3f origen = new Vector3f(this.getLocalTranslation());
			origen.setY(0.6f);
			// LLancem Raig endevant per veure si veiem algu 
			//System.out.println("Llancem raig cap a "+origen);
			PickResults resultats = llançarRaig(origen, this.getLocalRotation().getRotationColumn(2, new Vector3f()));
			if(hiHaJugadorDavant(resultats,temps)){
				Vector3f loc = this.getLocalTranslation();
				loc.addLocal(capOnMira()).multLocal(getVelocitat());
				this.setLocalTranslation(loc);
			}else{
				this.setLocalRotation(buscarAlVoltant(origen,temps));
			}
		}else{
			//System.out.println("Soc el NJ x i estic bloquejat: "+this.getName());
		}
		this.netejarFisiques();
		
	}
	
	private boolean esFillDUnPersonatge(Spatial node,float temps){
		boolean trobat=false;

		if(!node.equals(this.getParent()))
		{
			//if(node instanceof Personatge)
			if(node.getName().contains("Personatge"))
			{
				trobat=true;
				trobat = ((Personatge)node).socPersonatge();
				if(trobat){
					System.out.println("Em trobat el personatge!!!!!");
					trobat= (!((Personatge)node).estaBloquejat(temps) && !((Personatge)node).isImmune(temps));
				}
			}
			else trobat= esFillDUnPersonatge(node.getParent(),temps);
		}
		return trobat;
	}

}
