/**
 * 
 */
package eMdP.colisions;

import java.util.LinkedList;
import java.util.logging.Logger;

import com.jme.math.Vector3f;
import com.jme.scene.Node;
import com.jme.util.Timer;
import com.jmex.bui.BLabel;
import com.jmex.physics.PhysicsSpace;
import com.jmex.physics.contact.ContactCallback;
import com.jmex.physics.contact.PendingContact;

import eMdP.classesBasiques.Bustia;
import eMdP.classesBasiques.Escenari;
import eMdP.classesBasiques.Furgoneta;
import eMdP.classesBasiques.Paquet;
import eMdP.classesBasiques.Personatge;
import eMdP.estats.Partida;
import eMdP.gestors.GestorMusica;
import eMdP.gestors.GestorPantalla;

/**
 * @author redribbon
 *
 */
public class ImplCallBackBackUp {
	
	private static final Logger logger = Logger.getLogger(Partida.class.getName());

	private Personatge p;
		
	/**
     * ContactCallBack que ens informa de les col·lisions de qualsevol node Físic Dinàmic. Qualsevol col·lisió que un dels dos col·lisionats
     * sigui un paquet, la procesarem automàticament per aquest métode.
     */
    public ImplCallBackBackUp(PhysicsSpace espaiFisic, LinkedList<Furgoneta> furgonetes,final Node rootNode) {
    	
    	  ContactCallback myCallBack = new ContactCallback() {				
              public boolean adjustContact( PendingContact c ) {
            	  try{
            		  
            		  System.out.println("Colisiona node "+c.getNode1().getName()+" amb "+c.getNode2().getName());
            		  /* Col·lisió tipus 2 -> Personatge contra Paquet */
	            	  /* Col·lisió tipus 5 -> PNJ contra Paquet */
	            	  if(c.getNode1().getName().contains("Personatge") || c.getNode2().getName().contains("Personatge")){
	            		  //Collision Paquet <--> Player  o Paquet <--> PNJ
	            		  logger.info("CALLBACK::Col·lisiona Personatge contra Paquet. Tipus 2 o 5.ahdsfñlasdkfasñdlfk");
	            		  Personatge persona;
	            		  //Agafem el PErsonatge
	            		  if(c.getNode1().getName().contains("Personatge")){
	            			  persona = (Personatge)c.getNode1().getParent();
	            			  GestorMusica.reproduirCrit(0, persona.getWorldTranslation());
	            		  }else{
	            			  persona = (Personatge)c.getNode2().getParent();
	            		  }
	            		  System.out.println("aqui arrivem");
	            		  if(!persona.isImmune(Timer.getTimer().getTimeInSeconds())){   //SI el jugador no és immune, li afecten els paquets
		            		  //Eliminem 2 paquets del jugador
	            			//  System.out.println("aqui arrivem perfi "+persona.quantsPaquets());
		            		  int cont=0;
		            		/*  while(persona.quantsPaquets() > 0 && cont < 2){
		            			  System.out.println("entrem al while!!!!");
		            			  //Agafem el fill que comença a partir dels paquets
		            			  persona.getNodeEstatic().getChild(persona.quantsFills()-persona.quantsPaquets());
		            			  System.out.println("primera linia del while");
		            			  persona.getNodeEstatic().detachChildAt(persona.quantsFills()-persona.quantsPaquets());
		            			  System.out.println("segona linia del while!!!!");
		            			  cont++;
		            		  }*/
		            		  System.out.println("Bloquejem el Personatge!!!!!!:sdfdsapifjasdlkfnasdlfknasdlfkn");
		            		  persona.bloquejar(Timer.getTimer().getTimeInSeconds()+2);  //Esperem 2 segons sense poder moure el jugador
		      	    			//Hauriem de carregar una animació del Jugador estabilitzant-se
	            		  }else System.out.println("Soc immuneeeeeeeeeeeeeeeeeeeeeeee");
	            		  System.out.println("fi");
	            	  }
	            	  else if(c.getNode1().getParent() instanceof Bustia ||
	            			  c.getNode2().getParent() instanceof Bustia){
	            		  Paquet paq;Bustia bus;
	            		  if(c.getNode1().getParent().getName().substring(0, 6).equalsIgnoreCase("bustia")){
	            			  bus = (Bustia)c.getNode1().getParent();
	            			  paq = (Paquet)c.getNode2().getParent();
	            		  }else{
	            			  bus = (Bustia)c.getNode2().getParent();
	            			  paq = (Paquet)c.getNode1().getParent();
	            		  }
	            		  try{
	            			  
		            		  paq.clearDynamics();  //Netejem totes les Forces per tal de fer el control de colors
		            		  paq.unrest();
		            		  if(bus.getColor()==paq.getColor()){
		            			  /* Col·lisió tipus 6 -> Paquet contra Bústia Bona */
		            			  logger.info("CALLBACK::Col·lisiona Paquet contra bustia Bona. Tipus 6.");
		            			  paq.setActive(false);
		            			  paq.getLocalTranslation().set(-20,-8,-20);
		            			  //El fill 0 del rootNode és l'escenari, que d'ell pengen tots els jugadors, els jugadors comencen a la pos 1
		            			  p = (Personatge)((Escenari)rootNode.getChild(0)).getChild(paq.getIdPersonatge()+1);
		            			  
		            			  p.paquetEntrat();
		            			  //música que el paquet ha entrat a la bústia correcte!
		            			
		            			  paq.getNodeFisic().delete();
		            			  System.out.println("Abans de mataaaaaaaaaaaaaaaaaaaaaaaaaaaaa");
		            			  paq.getParent().detachChild(paq);
		            			  System.out.println("Despres de mataaaaaaaaaaaaaaaaaaaaaaaa");
		            			 // ((BLabel)GestorPantalla.getLlista().getLast().getFinestra().getComponent(4*p.getIdJugador()+3)).setText(""+p.quantsPaquetsHaEntrat());
		            			  
		            			  
		            		  }else{
		            			  /* Col·lisió tipus 7 -> Paquet contra Bústia Dolenta */
		            			  logger.info("CALLBACK::Col·lisiona Paquet contra bustia Dolenta. Tipus 7.");
		            			  GestorMusica.reproduirSoColisio(0,bus.getWorldTranslation());
		            			  Vector3f dirForsa = new Vector3f();
		            			  p = (Personatge)(rootNode.getChild(paq.getIdPersonatge()));
		                		//  dirForsa.set(p.getNodeEstatic().getWorldTranslation());
		                		  dirForsa.subtractLocal(bus.getWorldTranslation());
		                		  dirForsa.addLocal(0, 3f, 0);
		                		  paq.addForce(dirForsa);
		                		  paq.setHaEstatLlançat(true);
		            		  }
	            		  }catch(Exception e){logger.info("CALLBACK::El Paquet col·lisionat ja està eliminat");}
	            	  }else if(c.getNode1().isStatic() || c.getNode2().isStatic()){
	            		  /* Col·lisió tipus 8 -> Paquet contra Terreny i/o Personatge */
	            		  
	            		  Paquet p;
	            		  if(c.getNode1().isStatic()) p = (Paquet)c.getNode2().getParent();
	            		  else p = (Paquet)c.getNode2().getParent();
	            		  
	            		  if(!p.estaMort()){
		            		  if(p.sestaAutodestruint()){
		            			  if(p.matar(Timer.getTimer().getTimeInSeconds())){
		            				  logger.info("CALLBACK::Eliminem el Paquet "+p.getName());
		            				  p.mort();
		            				  Node n = (Node)p.getParent();
		            				  if(n.hasChild(p)){
		            					  n.detachChild(p);
		            				  }
		            				  p.setActive(false);
		            			  }
		            		  }else{
		            			  logger.info(c.getNode1().getParent().getName()+"CALLBACK::Col·lisiona Paquet amb terreny. Tipus 8"+c.getNode2().getParent().getName());
		            			  p.autodestruirme(Timer.getTimer().getTimeInSeconds(), 3.5f);
		            			  
		            		  }
	            		  }
	            	  }
	                  
	              }catch(Exception e){System.out.println("mmmmm peta!");e.printStackTrace();}
	              return true;
              }
          };
          
          espaiFisic.getContactCallbacks().add( myCallBack );

    }
 
}
