package eMdP.inputHandler.accions.EMdPHandler;



import com.jme.input.action.InputActionEvent;
import com.jme.input.action.KeyInputAction;
import com.jme.math.Vector3f;
import com.jme.util.Timer;

import eMdP.classesBasiques.Personatge;
import eMdP.inputHandler.EMdPHandler;

/**
 * 
 * <code>ThirdPersonBackwardAction</code>
 * 
 * @author Joshua Slack
 * @version $Revision: 4131 $
 */
public class EndarreraEMdPAction extends KeyInputAction {

    private Vector3f rot;

    private EMdPHandler handler;
    
    private Personatge personatge;

    /**
     * Constructor creates a new <code>ThirdPersonBackwardAction</code>
     * object. During construction, the node to direct and the speed at which to
     * move the node is set.
     * 
     * @param handler
     *            the associated handler
     * @param speed
     *            the speed at which the camera can move.
     */
    public EndarreraEMdPAction(EMdPHandler handler, float speed) {
        this.handler = handler;
        this.speed = speed;
        rot = new Vector3f();
        
        this.personatge = ((Personatge)handler.getJugador());
    }

    /**
     * <code>performAction</code> moves the node along it's positive direction
     * vector at a speed of movement speed * time. Where time is the time
     * between frames and 1 corresponds to 1 second.
     * 
     * @see com.jme.input.action.InputActionInterface#performAction(InputActionEvent)
     */
    public void performAction(InputActionEvent event) {
    	if(!((Personatge)handler.getJugador()).estaBloquejat(Timer.getTimer().getTimeInSeconds())){
	        handler.setGoingBackwards(true);
	        Vector3f loc = handler.getTarget().getLocalTranslation();
	        if (handler.isCameraAlignedMovement()) {
	            rot.set(handler.getCamera().getDirection());
	            rot.y = 0;
	        } else {
	            handler.getTarget().getLocalRotation().getRotationColumn(2, rot);
	        }
	        rot.normalizeLocal();
	        loc.subtractLocal(rot.multLocal((speed * event.getTime())));
	        if(!personatge.estaCaminant())
	        {
	        	personatge.posaCaminant();
	        }
    	}
    }
}
